# coding: utf-8

"""
    MoneyBox

    MoneyBox will help you better understand your finances, improve financial literacy, and achieve financial goals.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, constr, validator

class PatchedIncome(BaseModel):
    """
    PatchedIncome
    """
    id: Optional[StrictInt] = None
    created_at: Optional[datetime] = Field(None, description="Date and time of creation")
    updated_at: Optional[datetime] = Field(None, description="Date and time of last update")
    is_deleted: Optional[StrictBool] = None
    amount: Optional[constr(strict=True)] = None
    comment: Optional[constr(strict=True, max_length=255)] = None
    category: Optional[StrictInt] = None
    created_by: Optional[StrictInt] = None
    wallet: Optional[StrictInt] = None
    group: Optional[StrictInt] = None
    __properties = ["id", "created_at", "updated_at", "is_deleted", "amount", "comment", "category", "created_by", "wallet", "group"]

    @validator('amount')
    def amount_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^-?\d{0,8}(?:\.\d{0,2})?$", value):
            raise ValueError(r"must validate the regular expression /^-?\d{0,8}(?:\.\d{0,2})?$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedIncome:
        """Create an instance of PatchedIncome from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "id",
                            "created_at",
                            "updated_at",
                          },
                          exclude_none=True)
        # set to None if comment (nullable) is None
        # and __fields_set__ contains the field
        if self.comment is None and "comment" in self.__fields_set__:
            _dict['comment'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedIncome:
        """Create an instance of PatchedIncome from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedIncome.parse_obj(obj)

        _obj = PatchedIncome.parse_obj({
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "is_deleted": obj.get("is_deleted"),
            "amount": obj.get("amount"),
            "comment": obj.get("comment"),
            "category": obj.get("category"),
            "created_by": obj.get("created_by"),
            "wallet": obj.get("wallet"),
            "group": obj.get("group")
        })
        return _obj


